//****************************************************************************
//	apci57s.pas
//
//	aPCI-A57Tv\[X
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 2003/11/26
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit apci57s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci57w;

const
	szTitle = 'Sample';
	szA57	 = 'aPCI-A57';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:             String;
	dwDLLVer,dwDrvVer:  DWord;
	bResult:            Boolean;					// 
	wLogSlot:           Word;							// foCXi[
	ri:                 TAPCI57RESOURCE;	// \[X
  dwSwitchValue:      DWord;		        // [^XCb`̒l
	md:                 TAPCI57MODE;			// TvO[h
	dwNumData:          DWord;
	dwStatus:           DWord;
	Data:               TVXDBUFF;
	wDaData:            Word;					    // D/Af[^
	InValue:            Byte;						  // PIOf[^
  OutValue:           Byte;
	i:				          Integer;
	hWnd:			          THandle;
	InitArg:	          DWord;
begin
//---------------------------------------------------------------------------
	// apci57.dll ̎gp錾
	if Apci57wDllOpen() = False then
	begin
		ErrorMessage(APCI57_SLOT_AUTO);
		Halt;			// apci57.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aPCI-A57 DLL,Driver̃o[Wԍ擾
	if Apci57wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(APCI57_SLOT_AUTO);
		Halt;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Driver Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aPCI-A57̎gp錾
	wLogSlot := APCI57_SLOT_AUTO;		// gp̃foCXT܂B
	hWnd		:= 0;
	InitArg := 0;
	bResult := Apci57wCreate(wLogSlot,	// ꍇA̎̃foCXi[܂B
							hWnd,							// EBhEnhȂ̂NULLZbg܂B
																// EBhEnhZbg΁A
																// e탁bZ[W܂B
							$9157,						// 3ԖڂɃZbgẮAbZ[WID̊
																// ƂȂlłBۂ̃bZ[WID͂̊lɃI
																// tZbg(WM_EOCȂ)̂ƂȂ܂B
							InitArg);

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('aPCI-A57 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Apci57wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

//---------------------------------------------------------------------------
	// [^XCb`̒l擾
	if Apci57wGetSwitchValue(wLogSlot, dwSwitchValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'IO Base Address: %04xH-%04xH'#10 +
									 'IRQ: %2d'#10 +
                   'SwitchValue: %xH',
										 [szA57, ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
											ri.dwIRQRegisters[1],
                      dwSwitchValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
//	A/D 
//---------------------------------------------------------------------------
	// TvO[h̐ݒ
	md.dwChFirst := 0;		// TvOJn`l(0 ` 7)
	md.dwChLast	:=  7;		// TvOI`l(0 ` 7)
	md.cwBuffer := 256;		// obt@TCYi[hPʁj
	md.dwTimer	:= $15;		// ^C}l($15 = 500us)
	md.dwMode		:= APCI57_MODE_02;	// 샂[h(1`6)

	if Apci57wSetMode(wLogSlot, @md) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('aPCI-A57 Sampling Mode'#10 +
									 'TvOJn`l=%d'#10 +
									 'TvOI`l=%d'#10 +
									 'obt@TCY=%d'#10 +
									 '^C}l=%02xH'#10 +
									 '샂[h=%d',
									 [md.dwChFirst, md.dwChLast, md.cwBuffer,
										md.dwTimer, md.dwMode]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOJn
	if Apci57wStartSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aPCI-A57 Sampling Started');

//---------------------------------------------------------------------------
  // BUFFER FULL܂BUFFER OVERFLOWɂȂ܂ő҂
  dwStatus := 0;
  while ((dwStatus and (APCI57_STS_BUFF_FULL or APCI57_STS_BUFF_OVERFLOW)) = 0) do
  begin
    if Apci57wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False then
	  begin
      ErrorMessage(wLogSlot);
		  Halt;
    end;
  end;

//---------------------------------------------------------------------------
	// TvO~
	if Apci57wStopSampling(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aPCI-A57 Sampling Stopped');

//---------------------------------------------------------------------------
	// TvOEXe[^X̎擾
	if Apci57wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('TvOEXe[^X擾'#10 +
									 'f[^=%d'#10 +
									 'Xe[^X=%d',
									 [dwNumData, dwStatus]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// TvOς݃f[^̎擾
	if dwNumData > 0 then
	begin
		for i:=1 to (APCI57_ADCH_MAX)*(APCI57_BUFF_PCH_MAX-1) do Data[i]:=0;

		if Apci57wGetData(wLogSlot, dwNumData, @Data) = False then
		begin
			ErrorMessage(wLogSlot);
			Halt;
		end;

    if dwNumData > 99 then dwNumData := 99;	// f[^99ҏW甲悤ɂ

		strbuf := 'TvOς݃f[^擾'#10;
		for i := 1 to dwNumData -1 do
		begin
			strbuf := strbuf + Format('%d:%.xH	', [i, Data[i]]);

			if (i + 1) mod 4 = 0 then	// 4 Ŋ؂
				strbuf := strbuf + #10;
		end;

		ResultMessage(strbuf);
	end;

//---------------------------------------------------------------------------
//	D/A 
//---------------------------------------------------------------------------
	// o̓f[^̐ݒ
	wDaData := $0FFF;

	if Apci57wSetData(wLogSlot, APCI57_DACH_01, wDaData) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('D/Af[^o'#10 +
									 'D/A Data: %02xH',
									 [wDaData]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
//	PIO 
//---------------------------------------------------------------------------
	// Cӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Apci57wOutPort(wLogSlot, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('f[^o'#10 +
									 'Out Data: %02xH',
									 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// f[^ǂݍ
	InValue := Byte($00);

	if Apci57wInPort(wLogSlot, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	strbuf := Format('f[^'#10 +
									 'In Data: %02xH',
									 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aPCI-A57̎gpJ
	if Apci57wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Halt;
	end;

	ResultMessage('aPCI-A57 Closed');

	// apci57.dll ̎gpJ
	if Apci57wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Halt;			// apci57.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Apci57wGetLastError(wLogSlot);

	case dwRes of
		APCI57_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aPCI-A57 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
