//****************************************************************************
//	apci57w.pas
//
//	aPCI-A57
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 2003/11/26
//
//****************************************************************************

unit apci57w;

interface

uses
	Windows;

{ őXbg }
const
	APCI57_MAX_SLOTS	= 16;

{ _Xbgw }
const
	APCI57_SLOT_AUTO	= Word(not 0);

{ G[R[h̒` }
const
	APCI57_SUCCESS					    = 0;	  { I }
	APCI57_ERR_NO_DEVICE			  = 5000;	{ No device or not an aPCI-A57 }
	APCI57_ERR_RESOURCE				  = 5001;	{ Resource exhaustion }
	APCI57_ERR_INVALID_ARG			= 5002;	{ Invalid argument(s) }
	APCI57_ERR_SLOT					    = 5003;	{ _Xbgԍsłi܂͌܂j }
	APCI57_ERR_CHANNEL				  = 5004;	{ `lw肪sł }
	APCI57_ERR_TIMER				    = 5005;	{ ^C}lsł }
	APCI57_ERR_NOT_ENOUGH_MEM	  = 5006;	{ \ȃmۂł܂ł }
	APCI57_ERR_NUMDATA				  = 5007;	{ w肳ꂽ̃f[^obt@ɑ݂܂ }
	APCI57_ERR_NOT_CREATED			= 5008;	{ foCXNGCgĂ܂ }
	APCI57_ERR_START				    = 5009;	{ X^[gɎs܂B}
	APCI57_ERR_INVALID_FUNC			= 5010;	{ Ȋ֐Ăяoł }
	APCI57_ERR_IN_USE				    = 5011;	{ gp̃foCXł(NT) }
	APCI57_ERR_INTERNAL				  = 5100;	{ Send mail to us }
	APCI57_ERR_UNKNOWN				  = 5101;	{ Help me! }


const
	APCI57_BUFF_PCH_MAX = 4096;			{ 1ٓA/Dޯ̧MAX }

	APCI57_ADCH_MAX	 = 8;						{ A/Dِ }

{ TvO[h̒` }
const									{ START  SAMPLING	CLK   obt@[h }
	APCI57_MODE_01 = 1; { soft	 single	  ---   hCo }
	APCI57_MODE_02 = 2; { soft	 burst		timer hCo }
  APCI57_MODE_03 = 3; { extrg  single	  ---   hCo }
  APCI57_MODE_04 = 4; { extrg  burst		timer hCo }
	APCI57_MODE_05 = 5; { soft	 burst		timer foCX }
  APCI57_MODE_06 = 6; { extrg  burst		timer foCX }


{ bZ[W }
{ Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ }
{ ItZbglbZ[Wo܂B }
{$IFNDEF WM_EOC}
const
	WM_EOC							= 0; { VOTvO̊ }
	WM_BUFF_HALF_FULL		= 1; { Oobt@̃n[tt }
	WM_BUFF_FULL				= 2; { Oobt@̃t }
	WM_BUFF_OVERFLOW		= 3; { Oobt@̃I[o[t[ }
	WM_SAMPLING_OVERRUN = 4; { `lEI[gECNg̃I[o[ }
{$ENDIF}	{ WM_EOC }

// foCXXe[^XR[h
const
  APCI57_STS_SAMPLING         = $1;
  APCI57_STS_EOC			        = $2;
  APCI57_STS_BUFF_HALF_FULL   = $4;
  APCI57_STS_BUFF_FULL        = $8;
  APCI57_STS_BUFF_OVERFLOW    = $10;
  APCI57_STS_SAMPLING_OVERRUN = $20;

{ A/D`lݒl͈̔ }
const
	APCI57_ADCH_FIRST   = 	0;
  APCI57_ADCH_LAST	  =   7;

{ A/D`lݒl }
const
	APCI57_ADCH_01		  =   0;
	APCI57_ADCH_02		  =   1;
  APCI57_ADCH_03		  =   2;
  APCI57_ADCH_04		  =   3;
  APCI57_ADCH_05		  =   4;
  APCI57_ADCH_06		  =   5;
  APCI57_ADCH_07		  =   6;
  APCI57_ADCH_08		  =   7;

{ D/A`lݒl }
const
	APCI57_DACH_01		  =   0;
  APCI57_DACH_02		  =   1;

{ I/O\[XzE }
const
	APCI57_MAX_MEM				    =  9; { MAX_MEM_REGISTERS }
	APCI57_MAX_IO					    = 20;	{ MAX_IO_PORTS }
  APCI57_MAX_IRQ					  =  7;	{ MAX_IRQS }
  APCI57_MAX_DMA					  =  7;	{ MAX_DMA_CHANNELS }

{ ***** I/O\[X\ ***** }
{ YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B }
type
	TAPCI57RESOURCE = record
		dwNumMemWindows: DWord;																 { EBhE }
		dwMemBase:       array [1 .. APCI57_MAX_MEM] of DWord; { EBhEJnAhX }
		dwMemLength:     array [1 .. APCI57_MAX_MEM] of DWord; { EBhE }
		dwMemAttrib:     array [1 .. APCI57_MAX_MEM] of DWord; { EBhE }
		dwNumIOPorts:    DWord;																 { I/O|[g }
		dwIOPortBase:    array [1 .. APCI57_MAX_IO]  of DWord; { I/O|[gJnAhX }
		dwIOPortLength:  array [1 .. APCI57_MAX_IO]  of DWord; { I/O|[g }
		dwNumIRQs:       DWord;																 { IRQ }
		dwIRQRegisters:  array [1 .. APCI57_MAX_IRQ] of DWord; { IRQԍ }
		dwIRQAttrib:     array [1 .. APCI57_MAX_IRQ] of DWord; { IRQ }
		dwNumDMAs:       DWord;																 { DMA`l }
		dwDMALst:        array [1 .. APCI57_MAX_DMA] of DWord; { DMA`l }
		dwDMAAttrib:     array [1 .. APCI57_MAX_DMA] of DWord; { DMA`l }
		dwReserved1:     array [1 .. 3] of DWord;						   { \ }
	end;

PAPCI57R = ^TAPCI57RESOURCE;


{ ***** TvO[h\ ***** }
{ YfoCX̃TvO[hɊւDriver֓n߂̍\́B }
{ iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB }
type
	TAPCI57MODE = record
		dwChFirst: DWord;		// TvOJn`l(0 ` 7)
		dwChLast:  DWord;		// TvOI`l(0 ` 7)
		cwBuffer:  DWord;		// obt@TCYi[hPʁj
		dwTimer:   DWord;		// ^C}l(00H ` 3FH)
		dwMode:    DWord;		// 샂[h(1 ` 6)
	end;

PAPCI57M = ^TAPCI57MODE;

type
	{ A/Dޯ̧ }
	TADBUFF  = array [1..APCI57_ADCH_MAX, 1..APCI57_BUFF_PCH_MAX] of Word;
	TVXDBUFF = array [1..(APCI57_ADCH_MAX) * (APCI57_BUFF_PCH_MAX-1)] of Word;
	PADBUFF  = ^TADBUFF;
	PVXDNUFF = ^TVXDBUFF;

const
	APCI57_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	APCI57_DLL_NAME = 'apci57.dll';	{ DLL }


function Apci57wDllOpen: Boolean;		{ DLL [h }
function Apci57wDllClose: Boolean;	{ DLL A[h }


{ foCXhCoDLL̃o[W擾 }
function Apci57wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ foCX̎gp錾 }
function Apci57wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ foCX̊J錾 }
function Apci57wClose(wLogSlot: Word): Boolean;


{ I/O\[X̎擾 }
function Apci57wGetResource(wLogSlot: Word; pres: PAPCI57R): Boolean;

{ [^XCb`̒l擾 }
function Apci57wGetSwitchValue(wLogSlot: Word; var pdwSwitchValue: DWord): Boolean;

{ TvO[h̐ݒ }
function Apci57wSetMode(wLogSlot: Word; pcmode: PAPCI57M): Boolean;
{ TvOJn }
function Apci57wStartSampling(wLogSlot: Word): Boolean;
{ TvO~ }
function Apci57wStopSampling(wLogSlot: Word): Boolean;
{ TvOEXe[^X̎擾 }
function Apci57wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
{ TvOς݃f[^̎擾 }
function Apci57wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;


{ D/Af[^o }
function Apci57wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;


{ |[gf[^ }
function Apci57wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
{ |[gփf[^o }
function Apci57wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;


{ G[R[h̎擾 }
function Apci57wGetLastError(wLogSlot: Word): DWord;



implementation

type
	TApci57GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TApci57Create = function(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Bool; stdcall;
	TApci57Close = function(wLogSlot: Word): Bool; stdcall;
	TApci57GetResource = function(wLogSlot: Word; pres: PAPCI57R): Bool; stdcall;
  TApci57GetSwitchValue = function(wLogSlot: Word; var pdwSwitchValue: DWord): Bool; stdcall;
	TApci57SetMode = function(wLogSlot: Word; pcmode: PAPCI57M): Bool; stdcall;
	TApci57StartSampling = function(wLogSlot: Word): Bool; stdcall;
	TApci57StopSampling = function(wLogSlot: Word): Bool; stdcall;
	TApci57GetSamplingStatus = function(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Bool; stdcall;
	TApci57GetData = function(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Bool; stdcall;
	TApci57SetData = function(wLogSlot: Word; wChData: Word; wDaData: Word): Bool; stdcall;
	TApci57InPort = function(wLogSlot: Word; var pbInValue: Byte): Bool; stdcall;
	TApci57OutPort = function(wLogSlot: Word; bOutValue: Byte): Bool; stdcall;
	TApci57GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Apci57wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pApci57GetVersion: TApci57GetVersion;
	pApci57Create: TApci57Create;
	pApci57Close: TApci57Close;
	pApci57GetResource: TApci57GetResource;
  pApci57GetSwitchValue: TApci57GetSwitchValue;
	pApci57SetMode: TApci57SetMode;
	pApci57StartSampling: TApci57StartSampling;
	pApci57StopSampling: TApci57StopSampling;
	pApci57GetSamplingStatus: TApci57GetSamplingStatus;
	pApci57GetData: TApci57GetData;
	pApci57SetData: TApci57SetData;
	pApci57InPort: TApci57InPort;
	pApci57OutPort: TApci57OutPort;
	pApci57GetLastError: TApci57GetLastError;


//****************************************************************************
// 		apci57.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci57wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(APCI57_DLL_NAME);
	if hDLL = 0 then Exit;

	if Apci57wGetDllExportFunc = False then
	begin
		Apci57wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		apci57.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci57wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// 		aPCI-A57 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Apci57wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aPCI-A57̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
//				hWnd			 bZ[W𑗂EBhEnh
//				uWMBase		 ƂȂ郁bZ[WID
//				pvInitArg	 gp
// ߂l  True
//				s False
//****************************************************************************
function Apci57wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aPCI-A57̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Apci57wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Apci57wGetResource(wLogSlot: Word; pres: PAPCI57R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		[^XCb`̒l擾
// 		wLogSlot        ׂfoCX
//				pdwSwitchValue  [^XCb`̒l
// ߂l  True
//				s False
//****************************************************************************
function Apci57wGetSwitchValue(wLogSlot: Word; var pdwSwitchValue: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57GetSwitchValue(wLogSlot, pdwSwitchValue);
end;

//****************************************************************************
// 		TvO[h̐ݒ
// 		wLogSlot ݒ肷foCX
//				pcmode	 [hݒf[^
// ߂l  True
//				s False
//****************************************************************************
function Apci57wSetMode(wLogSlot: Word; pcmode: PAPCI57M): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57SetMode(wLogSlot, pcmode);
end;

//****************************************************************************
// 		TvOJn
// 		wLogSlot JnfoCX
// ߂l  True
//				s False
//****************************************************************************
function Apci57wStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57StartSampling(wLogSlot);
end;

//****************************************************************************
// 		TvO~
// 		wLogSlot ~foCX
// ߂l  True
//				s False
//****************************************************************************
function Apci57wStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57StopSampling(wLogSlot);
end;

//****************************************************************************
// 		TvOEXe[^X̎擾
// 		wLogSlot	 擾foCX
//				pcwNumData f[^obt@AhX
//				pdwStatus	 Xe[^XAhX
// ߂l  True
//				s False
//****************************************************************************
function Apci57wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus);
end;

//****************************************************************************
// 		TvOς݃f[^̎擾
// 		wLogSlot	擾foCX
//				cwNumData vf[^
//				Data			f[^obt@ւ̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Apci57wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57GetData(wLogSlot, cwNumData, Data);
end;

//****************************************************************************
// 	  D/Af[^o
// 	  wLogSlot _Xbg
//		  	wChData  ݃`l(0 ` 1)
//		  	wDaData  D/A݃f[^
// ߂l  True
//		  	s False
//****************************************************************************
function Apci57wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57SetData(wLogSlot, wChData, wDaData);
end;

//****************************************************************************
// 		|[gf[^
// 		wLogSlot	͂foCX
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Apci57wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57InPort(wLogSlot, pbInValue);
end;

//****************************************************************************
// 		|[gփf[^o
// 		wLogSlot	o͂foCX
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Apci57wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci57OutPort(wLogSlot, bOutValue);
end;

//****************************************************************************
// 		aPCI-A57̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Apci57wGetLastError(wLogSlot: Word): DWord;
begin
	Result := APCI57_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pApci57GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Apci57wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Apci57GetVersion ̃AhX擾
	pApci57GetVersion := GetProcAddress(hDLL, 'Apci57GetVersion');
	if @pApci57GetVersion = nil then Exit;

	// Apci57Create ̃AhX擾
	pApci57Create := GetProcAddress(hDLL, 'Apci57Create');
	if @pApci57Create = nil then Exit;

	// Apci57Close ̃AhX擾
	pApci57Close := GetProcAddress(hDLL, 'Apci57Close');
	if @pApci57Close = nil then Exit;

	// Apci57GetResource ̃AhX擾
	pApci57GetResource := GetProcAddress(hDLL, 'Apci57GetResource');
	if @pApci57GetResource = nil then Exit;

  // Apci57GetSwitchValue ̃AhX擾
  pApci57GetSwitchValue := GetProcAddress(hDLL, 'Apci57GetSwitchValue');
	if @pApci57GetSwitchValue = nil then Exit;

	// Apci57SetMode ̃AhX擾
	pApci57SetMode := GetProcAddress(hDLL, 'Apci57SetMode');
	if @pApci57SetMode = nil then Exit;

	// Apci57StartSampling ̃AhX擾
	pApci57StartSampling := GetProcAddress(hDLL, 'Apci57StartSampling');
	if @pApci57StartSampling = nil then Exit;

	// Apci57StopSampling ̃AhX擾
	pApci57StopSampling := GetProcAddress(hDLL, 'Apci57StopSampling');
	if @pApci57StopSampling = nil then Exit;

	// Apci57GetSamplingStatus ̃AhX擾
	pApci57GetSamplingStatus := GetProcAddress(hDLL, 'Apci57GetSamplingStatus');
	if @pApci57GetSamplingStatus = nil then Exit;

	// Apci57GetData ̃AhX擾
	pApci57GetData := GetProcAddress(hDLL, 'Apci57GetData');
	if @pApci57GetData = nil then Exit;

	// Apci57SetData ̃AhX擾
	pApci57SetData := GetProcAddress(hDLL, 'Apci57SetData');
	if @pApci57SetData = nil then Exit;

  // Apci57InPort ̃AhX擾
	pApci57InPort := GetProcAddress(hDLL, 'Apci57InPort');
  if @pApci57InPort = nil then Exit;

	// Apci57OutPort ̃AhX擾
	pApci57OutPort := GetProcAddress(hDLL, 'Apci57OutPort');
	if @pApci57OutPort = nil then Exit;

	// Apci57GetLastError ̃AhX擾
	pApci57GetLastError := GetProcAddress(hDLL, 'Apci57GetLastError');
	if @pApci57GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

