/******************************************************************************/
/*	apci57s.c																  */
/*																			  */
/*	aPCI-A57Tv\[X													  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include <windows.h>
#include <tchar.h>

#include "apci57w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szA57[]	 = _T("aPCI-A57");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024];
	TCHAR szTmp[20];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	APCI57RESOURCE ri;				// \[X
	DWORD dwSwitchValue;			// [^XCb`̒l
	APCI57MODE	   md;				// TvO[h
	DWORD dwNumData;
	DWORD dwStatus;
	PWORD pwData;
	WORD  wDaData;					// D/Af[^
	BYTE  InValue, OutValue;		// PIOf[^
	LONG  i;

/*---------------------------------------------------------------------------*/
	// apci57.dll ̎gp錾
	if (Apci57wDllOpen() == FALSE)
	{
		ErrorMessage(APCI57_SLOT_AUTO);
		return 1;			// apci57.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aPCI-A57 DLL,Driver̃o[Wԍ擾
	if (Apci57wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(APCI57_SLOT_AUTO);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("GetVersion\n")
							 _T("DLL Version: %08lxh\n")
							 _T("Drv Version: %08lxh"),
							 dwDLLVer,
							 dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-A57̎gp錾
	wLogSlot = APCI57_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Apci57wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							NULL,		// EBhEnhȂ̂NULLZbg܂B
										// EBhEnhZbg΁A
										// e탁bZ[W܂B
							0x9157,		// 3ԖڂɃZbgẮAbZ[WID̊
										// ƂȂlłBۂ̃bZ[WID͂̊lɃI
										// tZbg(WM_EOCȂ)̂ƂȂ܂B
							NULL);

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("aPCI-A57 Created\n\n")
							 _T("LogSlot: %2d"),
							 wLogSlot);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Apci57wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

/*---------------------------------------------------------------------------*/
	// [^XCb`̒l擾
	if (Apci57wGetSwitchValue(wLogSlot, &dwSwitchValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("Board Name: %s\n")
							 _T("NumPorts: %2d\n")
							 _T("IO Address: %04xh-%04xh\n")
							 _T("IRQ: %2d\n")
							 _T("SwitchValue: %xh"),
							 szA57,
							 ri.dwIOPortLength[0],
							 ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
							 ri.dwIRQRegisters[0],
							 dwSwitchValue);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
/*	A/D 																 */
/*---------------------------------------------------------------------------*/
	// TvO[h̐ݒ
	md.dwChFirst = 0;				// TvOJn`l(0 ` 7)
	md.dwChLast	= 7;				// TvOI`l(0 ` 7)
	md.cwBuffer = 256;				// obt@TCYi[hPʁj
	md.dwTimer	= 0x15;				// ^C}l(0x15 = 500us)
	md.dwMode	= APCI57_MODE_02;	// 샂[h(1`6)

	if (Apci57wSetMode(wLogSlot, &md) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("aPCI-A57 Sampling Mode\n")
							 _T("TvOJn`l=%ld\n")
							 _T("TvOI`l=%ld\n")
							 _T("obt@TCY=%ld\n")
							 _T("^C}l=%02xh\n")
							 _T("샂[h=%ld"),
							 md.dwChFirst, md.dwChLast, md.cwBuffer, md.dwTimer, md.dwMode);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOJn
	if (Apci57wStartSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-A57 Sampling Started"));

/*---------------------------------------------------------------------------*/
	// BUFFER FULL܂BUFFER OVERFLOWɂȂ܂ő҂
	do {
		if (Apci57wGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}
	} while (!(dwStatus & (APCI57_STS_BUFF_FULL | APCI57_STS_BUFF_OVERFLOW)));

/*---------------------------------------------------------------------------*/
	// TvO~
	if (Apci57wStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-A57 Sampling Stopped"));

/*---------------------------------------------------------------------------*/
	// TvOEXe[^X̎擾
	if (Apci57wGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("TvOEXe[^X擾\n")
							 _T("f[^=%ld\n")
							 _T("Xe[^X=%ld"),
							 dwNumData, dwStatus);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOς݃f[^̎擾
	if (dwNumData)
	{
		pwData = (PWORD)malloc(dwNumData * sizeof(WORD));
		memset(pwData, 0, dwNumData * sizeof(WORD));

		if (Apci57wGetData(wLogSlot, dwNumData, pwData) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		if (dwNumData > 32 )
			dwNumData = 32;

		_stprintf_s(szbuf, 1024, _T("TvOς݃f[^擾\n"));
		for (i = 0; i < (LONG)dwNumData; i++)
		{
			_stprintf_s(szTmp, 20, _T("%02ld:%03lxh\t"), i, pwData[i]);
			_tcscat_s(szbuf, 1024 - _tcslen(szbuf), szTmp);

			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				_tcscat_s(szbuf, 1024 - _tcslen(szbuf), _T("\n"));
		}

		ResultMessage(szbuf);

		free(pwData);
	}

/*---------------------------------------------------------------------------*/
/*	D/A 																 */
/*---------------------------------------------------------------------------*/
	// o̓f[^̐ݒ
	wDaData = 0x0FFF;

	if (Apci57wSetData(wLogSlot, APCI57_DACH_01, wDaData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("D/Af[^o\n")
							 _T("D/A Data: %03xh"),
							 wDaData);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
/*	PIO 																 */
/*---------------------------------------------------------------------------*/
	// Cӂ̃f[^o
	// o̓f[^ AAh
	OutValue = (BYTE)0xAA;

	if (Apci57wOutPort(wLogSlot, OutValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("f[^o\n")
							 _T("Out Data: %02xh"),
							 OutValue);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// f[^ǂݍ
	InValue = (BYTE)0x00;

	if (Apci57wInPort(wLogSlot, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	_stprintf_s(szbuf, 1024, _T("f[^\n")
							 _T("In Data: %02xh"),
							 InValue);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aPCI-A57̎gpJ
	if (Apci57wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aPCI-A57 Closed"));

/*---------------------------------------------------------------------------*/
	// apci57.dll ̎gpJ
	if (Apci57wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// apci57.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci57wGetLastError(wLogSlot);
	TCHAR szbuf[256];

	switch (dwRes)
	{
		case APCI57_ERR_WRAPDLL:
			_stprintf_s(szbuf, 256, _T("DLL Load error"));
			break;

		default:
			_stprintf_s(szbuf, 256, _T("aPCI-A57 error\n\n")
									_T("Error code: %08lxh"),
									dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
