/*****************************************************************************/
/*	apci57w.c																 */
/*																			 */
/*	aPCI-A57															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "apci57w.h"	// aPCI-A57

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Apci57wGetDllExportFunc();

/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pApci57GetVersion;
static FARPROC pApci57Create;
static FARPROC pApci57Close;
static FARPROC pApci57GetResource;
static FARPROC pApci57GetSwitchValue;
static FARPROC pApci57SetMode;
static FARPROC pApci57StartSampling;
static FARPROC pApci57StopSampling;
static FARPROC pApci57GetSamplingStatus;
static FARPROC pApci57GetData;
static FARPROC pApci57SetData;
static FARPROC pApci57InPort;
static FARPROC pApci57OutPort;
static FARPROC pApci57GetLastError;


/*****************************************************************************/
/* 	  apci57.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(APCI57_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Apci57wGetDllExportFunc() == FALSE)
	{
		Apci57wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  apci57.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aPCI-A57 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aPCI-A57̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W𑗂EBhEnh						 */
/*		  uWMBase	ƂȂ郁bZ[WID									 */
/*		  pvInitArg gp(NULLZbg)									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57Create)(pwLogSlot, hWnd, uWMBase, pvInitArg);
}

/*****************************************************************************/
/* 	  aPCI-A57̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wGetResource(WORD wLogSlot, PAPCI57R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  [^XCb`̒l擾										 */
/* 	  wLogSlot		 ׂfoCX										 */
/*		  pdwSwitchValue [^XCb`̒l								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57GetSwitchValue)(wLogSlot, pdwSwitchValue);
}

/*****************************************************************************/
/* 	  TvO[h̐ݒ											 */
/* 	  wLogSlot ݒ肷foCX											 */
/*		  pcmode   [hݒf[^̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wSetMode(WORD wLogSlot, PCAPCI57M pcmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57SetMode)(wLogSlot, pcmode);
}

/*****************************************************************************/
/* 	  TvOJn													 */
/* 	  wLogSlot JnfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wStartSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57StartSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvO~													 */
/* 	  wLogSlot ~foCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57StopSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvOEXe[^X̎擾									 */
/* 	  wLogSlot	 擾foCX										 */
/*		  pcwNumData f[^obt@AhX								 */
/*		  pdwStatus	 Xe[^XAhX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57GetSamplingStatus)(wLogSlot, pcwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  TvOς݃f[^̎擾										 */
/* 	  wLogSlot	擾foCX										 */
/*		  cwNumData vf[^											 */
/*		  pwData	f[^obt@ւ̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57GetData)(wLogSlot, cwNumData, pwData);
}

/*****************************************************************************/
/* 	  D/Af[^̏o													 */
/* 	  wLogSlot	o͂foCX										 */
/*		  wChData	݃`lw									 */
/*		  wDaData	o͂D/Af[^										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wSetData(WORD wLogSlot, WORD wChData, WORD wDaData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57SetData)(wLogSlot, wChData, wDaData);
}
/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wInPort(WORD wLogSlot, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57InPort)(wLogSlot, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Apci57wOutPort(WORD wLogSlot, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci57OutPort)(wLogSlot, bOutValue);
}

/*****************************************************************************/
/* 	  aPCI-A57̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Apci57wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return APCI57_ERR_WRAPDLL;

	return (*pApci57GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Apci57wGetDllExportFunc()
{
	// Apci57GetVersion ̃AhX擾
	pApci57GetVersion = GetProcAddress(hDLL, "Apci57GetVersion");
	if (pApci57GetVersion == NULL)
		return FALSE;

	// Apci57Create ̃AhX擾
	pApci57Create = GetProcAddress(hDLL, "Apci57Create");
	if (pApci57Create == NULL)
		return FALSE;

	// Apci57Close ̃AhX擾
	pApci57Close = GetProcAddress(hDLL, "Apci57Close");
	if (pApci57Close == NULL)
		return FALSE;

	// Apci57GetResource ̃AhX擾
	pApci57GetResource = GetProcAddress(hDLL, "Apci57GetResource");
	if (pApci57GetResource == NULL)
		return FALSE;

	// Apci57GetSwitchValue ̃AhX擾
	pApci57GetSwitchValue = GetProcAddress(hDLL, "Apci57GetSwitchValue");
	if (pApci57GetSwitchValue == NULL)
		return FALSE;

	// Apci57SetMode ̃AhX擾
	pApci57SetMode = GetProcAddress(hDLL, "Apci57SetMode");
	if (pApci57SetMode == NULL)
		return FALSE;

	// Apci57StartSampling ̃AhX擾
	pApci57StartSampling = GetProcAddress(hDLL, "Apci57StartSampling");
	if (pApci57StartSampling == NULL)
		return FALSE;

	// Apci57StopSampling ̃AhX擾
	pApci57StopSampling = GetProcAddress(hDLL, "Apci57StopSampling");
	if (pApci57StopSampling == NULL)
		return FALSE;

	// Apci57GetSamplingStatus ̃AhX擾
	pApci57GetSamplingStatus = GetProcAddress(hDLL, "Apci57GetSamplingStatus");
	if (pApci57GetSamplingStatus == NULL)
		return FALSE;

	// Apci57GetData ̃AhX擾
	pApci57GetData = GetProcAddress(hDLL, "Apci57GetData");
	if (pApci57GetData == NULL)
		return FALSE;

	// Apci57SetData ̃AhX擾
	pApci57SetData = GetProcAddress(hDLL, "Apci57SetData");
	if (pApci57SetData == NULL)
		return FALSE;

	// Apci57InPort ̃AhX擾
	pApci57InPort = GetProcAddress(hDLL, "Apci57InPort");
	if (pApci57InPort == NULL)
		return FALSE;

	// Apci57OutPort ̃AhX擾
	pApci57OutPort = GetProcAddress(hDLL, "Apci57OutPort");
	if (pApci57OutPort == NULL)
		return FALSE;

	// Apci57GetLastError ̃AhX擾
	pApci57GetLastError = GetProcAddress(hDLL, "Apci57GetLastError");
	if (pApci57GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
